stages:
  - analysis
  - build
  - tests

variables:
  PROJECT_NAME: "euromillions-calculator-2000"
  GIT_SUBMODULE_STRATEGY: recursive


linter:
  stage: analysis
  image: alpine:3.12
  before_script: 
    - apk add python3 py3-pip
    - pip3 install cpplint
  script:
    - cpplint  $(find -path ./src/third_party -prune -type f -o -name "*.cc" -o -name "*.h")


build_project:
  stage: build
  image: alpine:3.12
  before_script: 
    - apk add g++ ninja cmake gtest-dev
  script: 
    - mkdir -p ./build 
    - cd ./build 
    - cmake .. -G Ninja 
    - ninja
  artifacts:
    paths:
      - ./bin
    expire_in: 1 day
 

unit_tests:
  stage: tests
  image: alpine:3.12
  dependencies:
    - build_project
  before_script: 
    - apk add g++ gtest-dev
  script:
    - cd ./bin 
    - ./ec_2000_unit_tests

  
integration_tests:
  stage: tests
  image: alpine:3.12
  dependencies:
    - build_project
  before_script: 
    - apk add g++
  script:
    - cd ./bin
    - ./euromillions_calculator_2000 1 2 3 4 5 6 7
